import kv.schemas as schemas
import kv.crud as crud
from kv.database import get_db
from sqlalchemy.orm import Session
from fastapi import APIRouter, Depends
from typing import List
router = APIRouter()

"""get"""


@router.get("/get_withdrawing_types", response_model=List[schemas.WithdrawingTypesSerializer])
async def get_withdrawing_types(db: Session = Depends(get_db)):
    data = crud.RecalculationViewSet.get_withdrawing_types(db)
    return data


"""post"""


@router.post('/set_report_filter_list', response_model=List[schemas.WithdrawingCheckSerializer])
async def set_report_filter_list(request: schemas.WithdrawingCheckInit, db: Session = Depends(get_db)):
    return crud.RecalculationViewSet.set_report_filter_list(db, request)


@router.post('/get_withdrawing_temp', response_model=List[schemas.WithdrawingTempSerializer])
async def get_withdrawing_temp(request: schemas.WithdrawingTempInit, db: Session = Depends(get_db)):
    return crud.RecalculationViewSet.get_withdrawing_temp(db, request)


@router.post('/save_withdrawing')
async def save_withdrawing(request: schemas.WithdrawingSave, db: Session = Depends(get_db)):
    return crud.RecalculationViewSet.save_withdrawing(db, request)
